Subject: Plz help regarding implemetation of NETCONF over SSH

From: Shilpa Jayantilal Bharkhada <[email-masked]>
Date: Thu, 17 May 2007 17:03:48 +0530

Hi,
we r implementing netconf protocol.netconf over soap is over.
now we want to implement netconf over ssh.for that we have downloaded
openssh & mindterm client,but we r not getting actually how to start.plz can
u guide me.
plz tell me if there is any good site from which i can get some help.
bye & take care.
Thanks & Regards,

Shilpa
Senior Engineer -D & -D
Tata Elxsi,Bangalore-48

--
to unsubscribe send a message to [email-masked] with
the word 'unsubscribe' in a single line as the message text body.
archive: <http://ops.ietf.org/lists/netconf/>

---

From: Andy Bierman <[email-masked]>
Date: Fri, 18 May 2007 11:53:33 -0700

> plz tell me if there is any good site from which i can get some help.

I don't know of any WEB site to help you, but I can tell you
some of my implementation experience.

On the agent side, you can run a thin client as your openssh 'netconf'
subsystem, and connect to your agent process somehow to
establish the session.

On the client side, I found libssh2 much easier to use than
openssh.  Following the sftp code examples, it was pretty easy
to figure out how to connect to the netconf subsystem.

> Tata Elxsi,Bangalore-48

Andy

---

From: Andy Bierman <[email-masked]>
Date: Wed, 30 May 2007 06:59:03 -0700

Shilpa Jayantilal Bharkhada wrote:
> Hi Andy,
> Thnks for your input on this.We are able to write the client part of the
> implementation where a ssh client is connecting to port 22 (through a
> session and channel) and an agent side process (process a) is starting and
> waiting at port 830 to accept connections.We did the necessary configuration
> changes in /etc/ssh/sshd_config file.
> We are not able to figure out so far how to align this agent socket (process
> a) to SSH tuunnel once SSH creates this new subsystem at port 830.
> Will it be possible for you to help us how to achieve this ?

no -- this sounds like an implementation detail in the client code,
usually passed in the command line parameters to the client

> Thanking you in advance.
> With Regards,

Andy

---

From: Shilpa Jayantilal Bharkhada <[email-masked]>
Date: Wed, 30 May 2007 16:11:27 +0530

Hi Andy,

-----Original Message-----
From: Andy Bierman [mailto:[email-masked]]
Sent: Saturday, May 19, 2007 12:24 AM
To: Shilpa Jayantilal Bharkhada
Cc: [email-masked]
Subject: Re: Plz help regarding implemetation of NETCONF over SSH

Andy

---

From: Shilpa Jayantilal Bharkhada <[email-masked]>
Date: Wed, 30 May 2007 16:11:27 +0530

Hi Andy,

-----Original Message-----
From: Andy Bierman [mailto:[email-masked]]
Sent: Saturday, May 19, 2007 12:24 AM
To: Shilpa Jayantilal Bharkhada
Cc: [email-masked]
Subject: Re: Plz help regarding implemetation of NETCONF over SSH

Andy

---

From: Shilpa Jayantilal Bharkhada <[email-masked]>
Date: Thu, 31 May 2007 16:58:16 +0530

Hi Andy,
Sorry to bother you again on this.

Just wanted one more clarification for this if you could help.
When ssh client is being used to create the subsystem as in "ssh -s
ourserver.com -p 830 netconf" , I understand that the ssh client is directly
connecting to the netconf subsystem agent which is starting at port 830.

Is this the correct way for the client to connect to the netconf agent or
client should always connect to port 22 i.e to sshd server (and not directly
to 830) and ssh will take care of tunnelling the communication to the agent
app at 830 ?

Kindly help to understand section 3 of the RFC 4742 from your previous
implementation experience.I will highly appreciate this.
Any help in this regards from others will also be appreciated.
Regards,
Shilpa

-----Original Message-----
From: Andy Bierman [mailto:[email-masked]]
Sent: Wednesday, May 30, 2007 7:29 PM
To: Shilpa Jayantilal Bharkhada
Cc: [email-masked]
Subject: Re: Plz help regarding implemetation of NETCONF over SSH

Andy

---

From: Simon Leinen <[email-masked]>
Date: Thu, 31 May 2007 21:17:29 +0200

> Just wanted one more clarification for this if you could help.  When
> ssh client is being used to create the subsystem as in "ssh -s
> ourserver.com -p 830 netconf" , I understand that the ssh client is
> directly connecting to the netconf subsystem agent which is starting
> at port 830.

> Is this the correct way for the client to connect to the netconf
> agent

Yes.

> or client should always connect to port 22 i.e to sshd server (and
> not directly to 830) and ssh will take care of tunnelling the
> communication to the agent app at 830 ?

No.  IF you have an SSH client (or client library) that can only
connect to port 22, then tunneling might be a workaround for
connecting to a NETCONF server listening on the standard port 830.
But perhaps it would be easier to just use a better SSH client/library
instead.
-- 
Simon.

---

From: Juergen Schoenwaelder <[email-masked]>
Date: Thu, 31 May 2007 20:56:52 +0200

> connecting to the netconf subsystem agent which is starting at port 830.

An SSH server supporting NETCONF is expected to listen on port
830. You SSH to this transport endpoint and then you invoke the
NETCONF subsystem.
 
> agent or client should always connect to port 22 i.e to sshd server
> (and not directly to 830) and ssh will take care of tunnelling the
> communication to the agent app at 830?

There is no tunneling - the client connects to port 830. I am not
sure which text in section 3 makes you believe there is some magic
tunneling involved.

/js

-- 
Juergen Schoenwaelder           Jacobs University Bremen gGmbH
Phone: +49 421 200 3587         Campus Ring 1, 28759 Bremen, Germany
Fax:   +49 421 200 3103         <http://www.jacobs-university.de/>